from aiges.dto import Response, ResponseData, DataListNode, DataListCls

"""personal param"""
model_name = 'codellama_7b_instruction'
pretrain_model_name = '/home/models_hub/bigmodels/for_atp/codellama_7b_instruction'
token_path = '/home/models_hub/bigmodels/for_atp/codellama_7b_instruction'
zip_path = '/data1/cgzhang6/test_patch/3368023061274624/adapter.zip'
stream = 1
finetune_type = 'lora'
infer_type = 'base'
""""""

import sys
print(sys.path)

import importlib
module_path = f'ailab.inference_wrapper.huggingface.lora.nlp.wrapper'
wrapper_module = importlib.import_module(module_path)
Wrapper = getattr(wrapper_module, 'Wrapper')
wrapper = Wrapper()

def get_messages(text):
    message = {
        "messages": [ {
        "content": text, "role": 'user'
        } ]
    }
    import json
    return json.dumps(message)

def Init():
    import os
    os.environ['PRETRAINED_MODEL_NAME'] = model_name
    os.environ['FULL_MODEL_PATH'] = pretrain_model_name
    os.environ['TOKENIZER_PATH'] = token_path
    os.environ['FINETUNE_TYPE'] = finetune_type
    os.environ['INFER_TYPE'] = infer_type
    config = {}
    if stream:
        config['common.lic'] = 1
    wrapper.wrapperInit(config)

def LoadRes(key):
    zip_file_path = zip_path
    with open(zip_file_path, 'rb') as zip_file:
        # 读取压缩包的二进制数据
        zip_data = zip_file.read()
        # 计算数据长度
        zip_data_length = len(zip_data)

    list_node = DataListNode()
    list_node.key = str(key)
    list_node.data = zip_data
    list_node.len = zip_data_length

    req_data = DataListCls()
    req_data.list.append(list_node)
    wrapper.wrapperLoadRes(req_data, key)

def Once(key, text):
    http_node = DataListNode()
    http_node.key = 'messages'
    text_data = get_messages(text).encode('utf-8')
    http_node.data = text_data 
    http_data = DataListCls()
    http_data.list.append(http_node)
    wrapper.wrapperOnceExec({"res_id":key}, http_data, key)

def UnloadRes(key):
    wrapper.wrapperUnloadRes(key)

def StreamCreate(patch_id):
    params = {
        "patch_id":patch_id,
        "temperature":'0.5',
        "top_k":'4',
        "max_tokens":'2048'
    }
    s = wrapper.wrapperCreate(params, 'presid',patch_id)
    return s.handle

def StreamWrite(handle,text):
    http_node = DataListNode()
    http_node.key = 'messages'
    text_data = get_messages(text).encode('utf-8')
    http_node.data = text_data 
    http_data = DataListCls()
    http_data.list.append(http_node)

    wrapper.wrapperWrite(handle,http_data)

def StreamDestroy(handle):
    wrapper.wrapperDestroy(handle)

if __name__ == '__main__' :
    Init()
    LoadRes('11')
    # '今天天气'
    prompt = '写一个查询语句'
    if stream:
        handle_0 = StreamCreate('0')
        for i in range(3):
            StreamWrite(handle_0, prompt)
    else:
        Once('0', '什么是自然语言处理')
        Once('1', '什么是自然语言处理')
    #UnloadRes('1')


